#!/bin/sh
# Common Ml Auto Service server (CMAS)
#	Copyright 1993-2004 (C) SAITO Yasuhiro.
#	All rights reserved.
#
VERSION=@VER@

#
# Set path of sendmail
#
SENDMAIL=@SENDMAIL@

#
# Set local environment.
#
DOMAIN=@DOMAIN@
ORGDOM=@DOMAIN@
DRIVER=@DRIVER@
MSPOOL=@MSPOOL@
PATH=@PATH@
TMPDIR=@TMPDIR@
AWK=@AWK@
GREP=@GREP@
export PATH
umask 022

unset LANG >/dev/null 2>&1

# Get PID
MYPID=$$

# Get name of Mailing List.
ML=$1

LOOPCHECK="X-Check-Loop: $ML@$DOMAIN"

# Set work file.
HEAD=$TMPDIR/HEAD.$$
BODY=$TMPDIR/BODY.$$
TEMP=$TMPDIR/TEMP.$$
SEND=$TMPDIR/SEND.$$
SYSM=$TMPDIR/SYSM.$$
MAIL=$TMPDIR/MAIL.$$
TMP2=$TMPDIR/TMP2.$$
TMP3=$TMPDIR/TMP3.$$
FILE=$TMPDIR/FILE.$$

LKEY=$DRIVER/$ML/.LOCK
LOCK=$DRIVER/$ML/.LOCK.lock

SLKEY=$MSPOOL/$ML/spool/.SLOCK
SLOCK=$MSPOOL/$ML/spool/.spool.lock

DGSTFILE=$MSPOOL/$ML/spool/.digest

trap "rm -f $TMP2 $TMP3 $FILE $MAIL $HEAD $BODY $TEMP $SEND $SYSM $LOCK $SLOCK; exit 0" 0 1 2 3 15

# Save Article.
cat > $MAIL

# make lock key
if [ ! -f $LKEY ]
then
	touch $LKEY
fi

# check manual execute.
MANUALADD=
if [ $# -eq 2 ]
then
	MANUALADD="MANUAL"
fi

# Set default value.
. $DRIVER/config.default

if [ -f $DRIVER/$ML/config.$ML ]
then
	. $DRIVER/$ML/config.$ML
fi

# Make a log dir.
LOGDIR=$DRIVER/$ML/LOGS
if [ ! -d $LOGDIR ]
then
	mkdir $LOGDIR
fi

# get error log?
if [ "$ERRORLOG" = "DO" ]
then
	CMASLOG=$LOGDIR/cmaslog.$$

	trap "rm -f $CMASLOG $TMP2 $TMP3 $FILE $MAIL $HEAD $BODY $TEMP $SEND $SYSM $LOCK $SLOCK; exit 0" 0
	trap "rm -f $TMP2 $TMP3 $FILE $MAIL $HEAD $BODY $TEMP $SEND $SYSM $LOCK $SLOCK; exit 0" 1 2 3 15

	cat $MAIL > $CMASLOG
fi	

# Check change domain name.
if [ "$GENERICFROM" ]
then
	DOMAIN=$GENERICFROM
fi

SPOOL=$MSPOOL/$ML/spool
PROFILE=$MSPOOL/$ML/profile
GCOSFILE=$MSPOOL/$ML/profile/.gcos

# Member list
LIST=$DRIVER/$ML/$ML-member

# Deliver list
DELV=$DRIVER/$ML/$ML-list

# List of Post Only
POST=$DRIVER/$ML/$ML-postonly


# Confirm mail list
CNFM=$DRIVER/$ML/$ML-confirm

# change list flag
CHANGE=0

if [ ! -f $DELV ]
then
	touch $DELV
fi

if [ ! -f $LIST ]
then
	cat $DELV > $LIST
	egrep "^[0-9]* SEND" $LIST | sed -e 's/.*<//' -e 's/>.*//' > $DELV
fi

if [ ! "$MESSAGES" ]
then
	MESSAGES=messages
fi

# Make unix-from address.
if [ ! "$UNIXFROM" ]
then
    UNIXFROM=$ML-request@$DOMAIN
fi

MYADDRESS=$ML-control@$DOMAIN

# Change member list.
egrep "^[0-9][0-9][0-9] " $LIST 2>&1 > /dev/null
if [ $? -eq 0 ]
then
	# Get Lock.
	DELAY=`expr $MYPID % 6`

	# Get delay time.
	case "$DELAY" in
	0)	set 1 2 3 3 2 1 ;;
	1)	set 1 3 2 1 2 3 ;;
	2)	set 2 1 3 1 3 2 ;;
	3)	set 2 3 1 2 1 3 ;;
	4)	set 3 1 2 2 3 1 ;;
	*)	set 3 2 1 3 1 2 ;;
	esac

	umask 077
	until ln $LKEY $LOCK >/dev/null 2>&1
	do
		DELAY=$1
		shift
		set $@ $DELAY
		sleep $DELAY
	done
	# Lock comprele.
	umask 022

	# Update member list.
	if [ -f $LIST ]
	then
		sed -e '/^[0-9][0-9][0-9] /s/^/0/' $LIST >$TEMP
		cp $TEMP $LIST
		CHANGE=1
	fi

	# Update GCOS file.
	if [ -f $GCOSFILE ]
	then
		sed -e '/^[0-9][0-9][0-9] /s/^/0/' $GCOSFILE >$TEMP
		cp $TEMP $GCOSFILE
	fi

	# Rename user profiles.
	if cd $PROFILE
	then
		for f in [0-9][0-9][0-9]
		do
			mv $f 0$f
		done
	fi

	rm -rf $LOCK
fi

#
# Chage spool dir. (after CML-3.1)
#

#D=`find $SPOOL -type d -name "[0-9][0-9][0-9][0-9]000" -print`
D=`ls -d $SPOOL/[0-9][0-9][0-9][0-9]000/. 2>/dev/null`
if [ "$D" = "" ]
then
	if [ ! -f $SLKEY ]
	then
		touch $SLKEY
	fi

	DELAY=`expr $MYPID % 6`

	# set delay time
	case "$DELAY" in
	0)	set 1 2 3 3 2 1 ;;
	1)	set 1 3 2 1 2 3 ;;
	2)	set 2 1 3 1 3 2 ;;
	3)	set 2 3 1 2 1 3 ;;
	4)	set 3 1 2 2 3 1 ;;
	*)	set 3 2 1 3 1 2 ;;
	esac
	umask 077
	until ln $SLKEY $SLOCK >/dev/null 2>&1
	do
		DELAY=$1
		shift
		set $@ $DELAY
		sleep $DELAY
	done
	# lock complete

	I=0
	while :
	do
		D=`echo 0000${I}000 | sed -e 's/.*\(.......\)$/\1/'`
		F=`echo 0000${I}??? | sed -e 's/.*\(.....\)$/\1/'`

		FF=`find $SPOOL -type f -name "$F" -print`
		if [ "$FF" = "" ]
		then
			break
		fi

		if [ ! -d $SPOOL/$D.d ]
		then
			mkdir $SPOOL/$D.d
		fi

		for i in $FF
		do
			mv $i $SPOOL/${D}.d/00`basename $i`
		done

		mv $SPOOL/${D}.d $SPOOL/$D
		I=`expr $I + 1`
	done
	rm -rf $SLOCK
	umask 022
fi

# Get header
sed -n -e '1,/^$/p' < $MAIL > $HEAD

# Get body.
sed -e '1,/^$/d' < $MAIL > $BODY

# Check multi-part message in MIME format.
egrep -i "^Mime-Version:" $HEAD >/dev/null 2>&1
if [ $? -eq 0 ]
then
	CT=`$AWK '
	        BEGIN {rcv = 0;}
	        /^$/, NR == 0 { next;}
	        /^From / {next;}
	        /^[Cc][Oo][Nn][Tt][Ee][Nn][Tt]-[Tt][Yy][Pp][Ee]:/ {rcv = 1; print; next;}
	        /^[ 	]/ && rcv == 1 {print; next;}
	        {rcv = 0};'< $HEAD`

	echo $CT | grep -i "multipart" >/dev/null 2>&1
	if [ $? -eq 0 ]
	then
		echo $CT | grep -i "boundary=" >/dev/null 2>&1
		if [ $? -eq 0 ]
		then
			B=`echo $CT | sed -e 's/.*boundary=//' -e 's/\"//g'`
			echo "1,/^--${B}/d" > $TEMP
			sed -f $TEMP < $BODY | sed -e '1,/^$/d' > $TMP2
			echo "1,/^--${B}/p" > $TEMP
			sed -n -f $TEMP < $TMP2 > $BODY
		fi
	fi
fi

# Check header.
FROM=`$AWK '
	BEGIN {rcv = 0;}
	/^$/, NR == 0 { next;}
	/^From / {next;}
	/^[Ff][Rr][Oo][Mm]:/ {rcv = 1; print; next;}
	/^[ 	]/ && rcv == 1 {print; next;}
	{rcv = 0};' < $HEAD | sed 's/[Ff][Rr][Oo][Mm]: //'`

echo $FROM | $GREP "@" >/dev/null 2>&1
if [ $? -ne 0 ]
then
	GCOS="`echo $FROM | \
	sed  -e 's/<.*>//' -e 's/.*(//' -e 's/).*//' -e 's/[ 	]*$//'`"
	set `echo $FROM | sed -e "s/(.*)//" -e "s/.*<//" -e "s/>.*//"` "ERROR"
	AD=$1
        FROM="$AD@$ORGDOM ($GCOS)"
fi

if [ "$AD" = "ERROR" ]
then
	exit 0
fi

REPLYTO=`$AWK '
	BEGIN {rcv = 0;}
	/^$/, NR == 0 { next;}
	/^From / {next;}
	/^[Rr][Ee][Pp][Ll][Yy]-[Tt][Oo]:/ {rcv = 1; print; next;}
	/^[ 	]/ && rcv == 1 {print; next;}
	{rcv = 0};' < $HEAD | sed 's/[Rr][Ee][Pp][Ll][Yy]-[Tt][Oo]: //'`

if [ "$REPLYTO" ]
then
	echo $REPLYTO | $GREP "@" >/dev/null 2>&1
	if [ $? -ne 0 ]
	then
		GCOS="`echo $REPLYTO | \
		sed  -e 's/<.*>//' -e 's/.*(//' -e 's/).*//' -e 's/[ 	]*$//'`"
		set `echo $REPLYTO | sed -e "s/(.*)//" -e "s/.*<//" -e "s/>.*//"` 
		AD=$1
	        REPLYTO="$AD@$ORGDOM ($GCOS)"
	fi
fi

if [ "$REPLYTO" = "$ML@$DOMAIN" ]
then
	REPLYTO=
fi

# loop check
$GREP -i "$LOOPCHECK" $HEAD >/dev/null 2>&1
if [ $? -eq 0 ]
then
	echo "To: $ML-request@$DOMAIN ($ML ML admin)"		       > $HEAD
	echo "From: $ML-request@$DOMAIN ($ML ML admin)"		      >> $HEAD
	echo "Subject: Probably command mail does loop."	      >> $HEAD
	echo "Errors-To: $ML-request@$DOMAIN"			      >> $HEAD
	echo "$VHEAD"						      >> $HEAD

	if [ "$SENDER" ]
	then
		echo "Sender: $SENDER"				      >> $HEAD
	fi

	if [ "$PRECEDENCE" ]
	then
		echo "Precedence: $PRECEDENCE"			      >> $HEAD
	fi
	echo ""							      >> $HEAD
	echo "******************************"			      >> $HEAD
	echo "** Probably mail does loop. **"			      >> $HEAD
	echo "** Check original.          **"			      >> $HEAD
	echo "******************************"			      >> $HEAD
	echo "------------------------------------------------------" >> $HEAD

	cat $HEAD $MAIL | $SENDMAIL -oi -t -f$UNIXFROM
	exit 0

fi

set `$AWK '
	BEGIN {rcv = 0;}
	/^$/, NR == 0 { next;}
	/^From / {next;}
	/^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:/ {rcv = 1; print; next;}
	/^[ 	]/ && rcv == 1 {print; next;}
	{rcv = 0};'< $HEAD | sed 's/[Ss][Uu][Bb][Jj][Ee][Cc][Tt]: //' | 
	sed 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'` ""

SUBJECT=$1

# Save command mail log.
LOGF=$LOGDIR/cmaslog

# execute time.
TIME=`date | $AWK '{printf("%s %02d %s\n",$2,$3,$4)}' | sed -e 's/:..$//'`
TIME="[$TIME]"

case $ASLOGLEVEL in
1)
	echo "$TIME ** Command Mail Detect **" >> $LOGF
	echo "$TIME From    : $FROM"           >> $LOGF
	echo "$TIME Reply-To: $REPLYTO"        >> $LOGF
	echo "$TIME Subject : $SUBJECT"        >> $LOGF
	;;
2)
	echo "$TIME ** Command Mail Detect **"                     >> $LOGF
	echo "$TIME From    : $FROM"                               >> $LOGF
	echo "$TIME Reply-To: $REPLYTO"                            >> $LOGF
	echo "$TIME Subject : $SUBJECT"                            >> $LOGF
	echo "$TIME ** Mail Body (5lines) **"                      >> $LOGF
	head -5 $BODY | $AWK '{printf("               >%s\n",$0)}' >> $LOGF
	;;
3)
	echo "$TIME ** Command Mail Detect **"                       >> $LOGF
	cat $HEAD $BODY | $AWK '{printf("               >%s\n",$0)}' >> $LOGF
	;;
0|*)
	;;
esac

if [ -f $LOGF ]
then
	chmod o-r $LOGF
	chmod o-w $LOGF
	chmod o-x $LOGF
fi

# Make user address.
ERROR=0
if [ "$REPLYTO" ]
then
	ADDRESS=`echo $REPLYTO | sed -e "s/(.*)//" -e "s/.*<//" -e "s/>.*//"`
elif [ "$FROM" ]
then
	ADDRESS=`echo $FROM | sed -e "s/(.*)//" -e "s/.*<//" -e "s/>.*//"`
else
	ADDRESS=$ML-request
	ERROR=1
fi

set $ADDRESS .
ADDRESS=$1

# Get GCOS field.
GCOS="__SGCOS__`echo $FROM | sed  -e 's/<.*>//' -e 's/.*(//' -e 's/).*//'`__EGCOS__"

if [ "__SGCOS__${FROM}__EGCOS__" = "$GCOS" ]
then
	GCOS=
fi

SENDSUB="Control command '$SUBJECT' execute"

if [ "$MANUALADD" ]
then
	SUBJECT=MANUALADD
	SENDSUB="Appending message from $ML ML admin"
	AUTOADD="DO"
fi

TOMEMB=0
TOUSER=0
ORGADRS=

if [ "$SUBJECT" = "ACKNOWLEDGE" -a "$CONFIRM" = "DO" ]
then
	ERROR=0
	set `egrep -v '[*?[]' $BODY` .
	NUM="`echo 0000$1 | sed -e 's/.*\(....\)$/\1/'`"
	ADD=$2
	USR=`egrep "^$NUM" $CNFM`
	if [ "$USR" ]
	then
		set `echo $USR` .
		ORGADD=$2

		if [ "$ADD" != "$ORGADD" ]
		then
			ERROR=1
		fi
	else
		ERROR=1
	fi

	if [ $ERROR -eq 1 ]
	then
		echo "s/%MlNaMe%/$ML@$DOMAIN/
		      s/%AdMiN%/$ML-request@$DOMAIN/" > $TEMP

		sed -f $TEMP < $DRIVER/$MESSAGES/confirm.err        > $SEND

		echo "To: $ADDRESS"                                 > $HEAD
		echo "From: $ML-request@$DOMAIN ($ML ML admin)"    >> $HEAD
		echo "Subject: Confirmarion your append mail."     >> $HEAD
		echo "Reply-To: $ML-request@$DOMAIN"               >> $HEAD
		echo "Errors-To: $ML-request@$DOMAIN"              >> $HEAD
		echo "X-ML-Driver: CMAS (Version $VERSION)"        >> $HEAD
		echo $LOOPCHECK					   >> $HEAD

		if [ "$SENDER" ]
		then
			echo "Sender: $SENDER"                     >> $HEAD
		fi

		if [ "$PRECEDENCE" ]
		then
			echo "Precedence: $PRECEDENCE"             >> $HEAD
		fi
		echo ""                                            >> $HEAD

		cat $HEAD $SEND | b64decode| $SENDMAIL -oi -t -f$UNIXFROM

		exit 0
	else
		SUBJECT="ACKAPPEND"
		sed -n -e '/^./,$p' < $BODY > $TEMP
		set `wc -l $TEMP`
		LINE=`expr $1 - 1`

		tail -$LINE $TEMP > $BODY

                echo "/^$NUM /d
                      w
                      q
                " | ed >/dev/null 2>&1 $CNFM
	fi		
fi

case $SUBJECT in
GET|GETDGST|LIST)
	if [ "$ARCHIVE" != "DO" ]
	then
		ERROR=1
		SUBJECT="X-$SUBJECT"
		TOUSER=1
	fi

	if [ "$ACCESSFREE" != "DO" ]
	then
		set `egrep -v '[*?[]' $BODY` .
		NUM="`echo 0000$1 | sed -e 's/.*\(....\)$/\1/'`"
		KEY=$2
		USER=`egrep "^$NUM" $LIST`
		if [ "$USER" ]
		then
			set `echo $USER` .
			ORGKEY=$4

			if [ "$KEY" != "$ORGKEY" ]
			then
				ERROR=1
			fi
		else
			ERROR=1
		fi
	fi
	;;
esac

case $SUBJECT in
ADMINCMD)
	$DRIVER/cmad $ML < $MAIL
	exit 0
	;;
GET|GETDGST|LIST)
	# Command is 'Get saved article'.

	cd $SPOOL
	ls -R * | egrep "[0-9][0-9][0-9][0-9][0-9][0-9][0-9]$" >$TMP2
	FILEMIN=`head -1 $TMP2`
	FILEMAX=`tail -1 $TMP2`

	# check command line
	cat $BODY | \
	sed 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/' | \
	sed -e "s/^[ 	]*//" |\
	egrep "^$SUBJECT" | \
		sed -e 's/GETDGST//' -e 's/GET//' -e 's/LIST//' > $TEMP
	sed 's/[	 ,]/\
/g' <$TEMP | $AWK -F- '
		{ filemin += 0; filemax += 0 }
		/^ALL$/	{
			for (i = filemin; i <= filemax; ++i)
				printf("%07d\n", i)
			next
		}
		/^-$/	{
			exit 1
		}
		/^[0-9]*-[0-9]*$/	{
			min = $1
			if (min == "")
				min = filemin
			max = $2
			if (max == "")
				max = filemax
			for (i = min; i <= max; ++i)
				printf("%07d\n", i)
			next
		}
		/^[0-9]+$/	{
			printf("%07d\n", $1)
			next
		}
		/.+/	{
			exit 1
		}
	' filemin=$FILEMIN filemax=$FILEMAX - >$TMP3

	if [ $? -eq 0 ]
	then
		sort -nu $TMP3 | comm -12 $TMP2 - > $FILE

		if [ ! -s $FILE ]
		then
			cat $DRIVER/$MESSAGES/noart		> $SEND
			sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $HEAD >> $SEND
			cat $BODY			       >> $SEND

			SENDSUB="No article in archive."
			TOUSER=1
			TOMEMB=0
			SUBJECT=
		else
			$AWK '{
				f = $0
				d = $0 / 1000
				printf("%04d000/%07d\n", d, f)
			}' < $FILE > $TMP2

			cat $TMP2 > $FILE
		fi
	else
		ERROR=1
		SUBJECT=
	fi

	if [ "$SUBJECT" = "LIST" ]
	then
		if [ "$LISTLIMIT" ]
		then
			LISTLIMIT=`expr $LISTLIMIT + 1`
			set `cat $FILE` .
			if [ $# -gt $LISTLIMIT ]
			then
				echo "s/%LiStLiMiT%/$LISTLIMIT/" > $TEMP
				sed -f $TEMP < $DRIVER/$MESSAGES/biglist> $SEND
				sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $HEAD >> $SEND
				cat $BODY		       >> $SEND

				SENDSUB="Too big lists"
				TOUSER=1
				TOMEMB=0
				SUBJECT=
			fi
		fi
	fi
	case $SUBJECT in
	GET)
		cp /dev/null $TEMP
		split $FILE $FILE-
		for i in `ls $FILE-??`
		do
			tar rf $TEMP `cat $i`
		done
		rm -f $FILE-??
		cat $TEMP | compress | uuencode files.tar.Z  > $SEND

		if [ "$GETLIMIT" ]
		then
			set `wc -c $SEND` 0
			S=$1
			GETLIMIT=`expr $GETLIMIT \* 1000`
			set $FILES
			if [ $# -gt 1 -a $S -gt $GETLIMIT ]
			then
				echo "s/%GeTlImIt%/$GETLIMIT/
				      s/%SiZe%/$S/" >$TEMP
				sed -f $TEMP < $DRIVER/$MESSAGES/bigart > $SEND
				sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $HEAD >> $SEND
				cat $BODY                      >> $SEND
				SENDSUB="Too big archive"
				TOMEMB=0
			fi
		fi
		TOUSER=1
		;;
	GETDGST)
		echo "-------- $ML ML Archive --------"	> $SEND
		echo ""					>> $SEND

		split $FILE $FILE-
		S=0
		for i in `ls $FILE-??`
		do
		    if [ $S -eq 1 ]
		    then	
			echo ""				>> $SEND
			echo "--------"			>> $SEND
			echo ""				>> $SEND
		    fi
		    S=1
		    $AWK '
			filename != FILENAME	{
				if (filename != "") {
					print ""
					print "--------"
					print ""
				}
				filename = FILENAME
			}
			/^-/	{
				print "- " $0
				next
			}
			{
				print
			}
		    ' `cat $i`				>> $SEND
		done
		rm -f $FILE-??

		echo ""					>> $SEND
		echo "-------- End of Archive  -------"	>> $SEND

		if [ "$GETLIMIT" ]
		then
			set `wc -c $SEND` 0
			S=$1
			GETLIMIT=`expr $GETLIMIT \* 1000`
			set `cat $FILE` .
			if [ $# -gt 1 -a $S -gt $GETLIMIT ]
			then
				echo "s/%GeTlImIt%/$GETLIMIT/
				      s/%SiZe%/$S/" >$TEMP
				sed -f $TEMP < $DRIVER/$MESSAGES/bigart > $SEND
				cat $HEAD                              >> $SEND
				cat $BODY                              >> $SEND

				SENDSUB="Too big archive"
				TOMEMB=0
			fi
		fi
		TOUSER=1
		;;
	LIST)
		cd $SPOOL
		cat /dev/null $SEND
		for i in `ls`
		do
		    $AWK '
			filename != FILENAME	{
				print filename ":" subject " =" from " (" l ")"
				filename = FILENAME
				subject = ""
				from = ""
				l = 0
				flushing = 0
			}
			{ l += length($0) + 1 }
			flushing == 1		{
				next
			}
			/^[Ff][Rr][Oo][Mm]:/	{
				from = substr($0, 6)
				next
			}
			/^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]: \[[A-z0-9=+-]*:[0-9]*\]/ || \
			/^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]: \[[A-z0-9=+-]*\]/	{
				subject = substr($0, index($0, "]") + 1)
				next
			}
			/^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:/ {
				subject = substr($0, 9)
				next
			}
			END {print filename ":" subject " =" from " (" l ")"}
		    ' `grep "^$i" $FILE` | egrep '^[0-9]' | \
		    sed -e 's/[0-9][0-9][0-9][0-9][0-9][0-9][0-9]\///' >> $SEND
		done

		TOUSER=1
		;;
	*)
		;;
	esac
	;;
HELP|MANUAL)
	REPLYTO=$ML-control@$DOMAIN
	echo "s/%AdMiN%/$ML-request@$DOMAIN/
	      s/%CNtLAdRs%/$MYADDRESS/
	      s/%MlNaMe%/$ML@$DOMAIN/"	> $TEMP

	if [ "$USECHECK" != "DONT" ]
	then
		echo "s/^((//" >> $TEMP
	else
		echo "/^((/d" >> $TEMP
	fi

	if [ "$USEMEMBER" != "DONT" ]
	then
		echo "s/^))//" >> $TEMP
	else
		echo "/^))/d" >> $TEMP
	fi

	if [ "$ARCHIVE" = "DO" ]
	then
		if [ "$ACCESSFREE" = "DO" ]
		then
			echo "s/^&&//" >> $TEMP
			echo "/^%%/d" >> $TEMP
		else
			echo "s/^%%//" >> $TEMP
			echo "/^&&/d" >> $TEMP
		fi
	else
		echo "/^%%/d" >> $TEMP
		echo "/^&&/d" >> $TEMP
	fi

	sed -f $TEMP < $DRIVER/$MESSAGES/help			 > $SEND
	if [ -f $DRIVER/$ML/info.$ML ]
	then
		echo "--<Information of $ML ML>----------"	>> $SEND
		cat $DRIVER/$ML/info.$ML			>> $SEND
	fi
	sed -f $TEMP < $DRIVER/$MESSAGES/manual			>> $SEND

	TOUSER=1
	;;
CHECK)
	if [ "$USECHECK" != "DONT" ]
	then
		#sed -e 's/</(/g' -e 's/>/)/g' < $LIST | \
		#	$GREP -i "($ADDRESS)" >/dev/null 2>&1

		cat $POST $LIST | \
			sed -e 's/ .... [<(]/ /' -e 's/[)>].*//' \
			    -e 's/[<(]//' | \
			sort | uniq | \
			awk '{ printf("%s (%s)\n", $1, $2 )}' | \
			$GREP -i "($ADDRESS)" >/dev/null 2>&1

		if [ $? -eq 0 ]
		then

			echo "s/%MlNaMe%/$ML@$DOMAIN/
			      s/%AdReSs%/$ADDRESS/" > $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/check1 >>$SEND

			for N in `cat $POST $LIST | \
				sed -e 's/ .... [<(]/ /' -e 's/[)>].*//' \
				    -e 's/[<(]//' | \
				sort | uniq | \
				awk '{ printf("%s (%s)\n", $1, $2 )}' | \
				$GREP -i "($ADDRESS)" | awk '{ print $1 }'`
			do
				set `sed -e 's/</(/g' -e 's/>/)/g' < $LIST | \
					$GREP -i "^$N"`

				NU=$1
				ST=$2
				AD=`echo $3 | \
				    sed -e "s/<//" -e "s/>//" \
				        -e "s/(//" -e "s/)//"`
				PW=$4

				GC="`$GREP $NU $GCOSFILE | 
				     sed -e 's/^[0-9]* //' \
				         -e 's/[ 	]*$//' \
					 -e 's/\\\\/\\\\\\\\/g' \
					 -e 's/\\//\\\\\\//g'	\
					 -e 's/&/\\\\&/g'`"

				if [ "$GC" != "" ]
				then
					AD="$AD ($GC)"
				fi

				echo "s/%NuMbEe%/$NU/
				      s/%SMoDe%/$ST/
				      s/%KeYwOrD%/$PW/
				      s/%AdDrEsS%/$AD/" > $TEMP

				sed -f $TEMP < $DRIVER/$MESSAGES/check2 >>$SEND

				PO="`$GREP $NU $POST`"
				if [ "$PO" != "" ]
				then
					cat $DRIVER/$MESSAGES/check-post>>$SEND
					echo "$PO" | \
					    sed -e 's/<//' -e 's/>//' | \
					    $AWK '{printf("\t\t\t%s\n",$2)}'>>$SEND
				fi
				echo "" >> $SEND
			done
			TOUSER=1
		else
			echo "s/%AdDrEsS%/$ADDRESS/" > $TEMP
			sed -f $TEMP < $DRIVER/$MESSAGES/nolist >> $SEND
			TOUSER=1
		fi
	else
		ERROR=1
	fi
	;;
APPEND|MANUALADD|ACKAPPEND)
	REPLYTO=$ML-control@$DOMAIN
	if [ "$SUBJECT" = "APPEND" -a "$CONFIRM" = "DO" ]
	then
		KEY=`echo 0000$MYPID | sed -e 's/.*\(....\)$/\1/'`

		while :
		do
			egrep "^$KEY" $CNFM >/dev/null 2>&1
			if [ $? -ne 0 ]
			then
				break
			fi

			KEY=`expr $KEY + 1`
			KEY=`echo 0000$KEY | sed -e 's/.*\(....\)$/\1/'`
		done

		SEDADD=`echo $ADDRESS | sed  -e 's/\\\\/\\\\\\\\/g' \
					     -e 's/\\//\\\\\\//g'   \
					     -e 's/&/\\\\&/g'`

		echo "s/%KeY%/$KEY/
		      s/%CNtLAdRs%/$MYADDRESS/
		      s/%AdDrEsS%/$SEDADD/
		      s/%AdMiN%/$ML-request@$DOMAIN/
		      s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP

		sed -f $TEMP <  $DRIVER/$MESSAGES/confirm            > $SEND
		sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $MAIL >> $SEND

		echo "$KEY $ADDRESS (`date`)"                      >> $CNFM

		echo "To: $ADDRESS"                                 > $HEAD
		echo "From: $ML-request@$DOMAIN ($ML ML admin)"    >> $HEAD
		echo "Subject: Confirmarion your append mail."     >> $HEAD
		echo "Reply-To: $MYADDRESS"                        >> $HEAD
		echo "Errors-To: $ML-request@$DOMAIN"              >> $HEAD
		echo "X-ML-Driver: CMAS (Version $VERSION)"        >> $HEAD
		echo $LOOPCHECK					   >> $HEAD

		if [ "$SENDER" ]
		then
			echo "Sender: $SENDER"                     >> $HEAD
		fi

		if [ "$PRECEDENCE" ]
		then
			echo "Precedence: $PRECEDENCE"             >> $HEAD
		fi
		echo ""                                            >> $HEAD

		cat $HEAD $SEND | b64decode| $SENDMAIL -oi -t -f$UNIXFROM

	elif [ "$AUTOADD" = "DO" ]
	then

		# Get Lock.
		DELAY=`expr $MYPID % 6`

		# Get delay time.
		case "$DELAY" in
		0)	set 1 2 3 3 2 1 ;;
		1)	set 1 3 2 1 2 3 ;;
		2)	set 2 1 3 1 3 2 ;;
		3)	set 2 3 1 2 1 3 ;;
		4)	set 3 1 2 2 3 1 ;;
		*)	set 3 2 1 3 1 2 ;;
		esac

		umask 077
		until ln $LKEY $LOCK >/dev/null 2>&1
		do
			DELAY=$1
			shift
			set $@ $DELAY
			sleep $DELAY
		done
		# Lock comprele.
		umask 022

		# Add user address to member list.
		if [ ! -f $LIST ]
		then
			if [ ! -d $DRIVER/$ML ]
			then
				mkdir $DRIVER/$ML
			fi
			NUM=0001
		else
			NUM=`sort -n $LIST | tail -1 | $AWK '{ print $1 }'`
			if [ ! "$NUM" ]
			then
				NUM=0
			fi
			NUM=`expr $NUM + 1`
			NUM=`echo 0000$NUM | sed -e 's/.*\(....\)$/\1/'`
		fi

		ID=`echo $ADDRESS | sed -e 's/@.*//'`
		KEY=`echo 0000$MYPID | sed -e  's/.*\(....\)$/\1/'`

		# Duplicate check.
		sed -e 's/</(/g' -e 's/>/)/g' < $LIST | \
			 $GREP -i "($ADDRESS)" >/dev/null 2>&1
		if [ $? -eq 0 ]
		then
			set `sed -e 's/</(/g' -e 's/>/)/g' < $LIST | \
				$GREP -i "($ADDRESS)"`
			NU=$1
			ST=$2
			AD=`echo $3 | \
			    sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			GC="`$GREP $NU $GCOSFILE |
			     sed -e 's/^[0-9]* //' -e 's/[ 	]*$//' \
				 -e 's/\\\\/\\\\\\\\/g' \
				 -e 's/\\//\\\\\\//g'	\
				 -e 's/&/\\\\&/g'`"

			if [ "$GC" != "" ]
			then
				AD="$AD ($GC)"
			fi

			echo "s/%MlNaMe%/$ML@$DOMAIN/
			      s/%NuMbEe%/$NU/
			      s/%SMoDe%/$ST/
			      s/%KeYwOrD%/$PW/
			      s/%AdDrEsS%/$AD/" > $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/duplicate  > $SEND

			PO="`$GREP $NU $POST`"
			if [ "$PO" != "" ]
			then
				cat $DRIVER/$MESSAGES/check-post    >> $SEND
				echo "$PO" | \
					$AWK '{printf("	%s\n",$2)}' >> $SEND
			fi

			TOUSER=1
		else
			USERINFO="$NUM SEND <$ADDRESS> $KEY"
			SMODE="SEND"
			# check default digest
			if [ "$DGSTAPPEND" = "DO" ]
			then
				FROMDOM=`echo $ADDRESS |\
		                $AWK '{
		                        l = length($0);

		                        for ( ; l > 0; l-- ) {
		                                printf("%s",substr($0, l, 1));
                	        	}
					printf( "\n" );
		                }' | sed -e 's/@.*//' | \
		                $AWK '{
		                        l = length($0);

		                        for ( ; l > 0; l-- ) {
		                                printf("%s",substr($0, l, 1));
		                        }
		                        printf( "\n" );
		                }'`

				if [ -f $DRIVER/$ML/defaultdigest ]
				then
					for i in `cat $DRIVER/$ML/defaultdigest`
					do
						echo $FROMDOM | $GREP "$i" >/dev/null 2>&1
						if [ $? -eq 0 ]
						then
							USERINFO="$NUM DGST ($ADDRESS) $KEY <nobody>"
							SMODE="DGST"
						fi
					done
				fi
			fi
			echo $USERINFO >> $LIST
			CHANGE=1

			# Write user profile.
			if [ ! -d $PROFILE ]
			then
				mkdir $PROFILE
			fi

			if [ -s $BODY ]
			then
				echo "<<Last Modified: `date`>>" >$PROFILE/$NUM
				cat $BODY			>>$PROFILE/$NUM
			fi

			echo "$NUM `echo $GCOS | sed -e 's/^__SGCOS__//' -e 's/__EGCOS__$//'`" | b64decode >> $GCOSFILE

			SEDADD=`echo $ADDRESS | sed  -e 's/\\\\/\\\\\\\\/g' \
						     -e 's/\\//\\\\\\//g'   \
						     -e 's/&/\\\\&/g'`

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$SEDADD/
			      s/%kEyWd%/$KEY/
			      s/%AdMiN%/$ML-request@$DOMAIN/
			      s/%CNtLAdRs%/$MYADDRESS/
			      s/%MlNaMe%/$ML@$DOMAIN/
			      s/%mOdE%/$SMODE/" > $TEMP
			if [ "$USECHECK" != "DONT" ]
			then
				echo "s/^((//" >> $TEMP
			else
				echo "/^((/d" >> $TEMP
			fi

			if [ "$USEMEMBER" != "DONT" ]
			then
				echo "s/^))//" >> $TEMP
			else
				echo "/^))/d" >> $TEMP
			fi


			if [ "$ARCHIVE" = "DO" ]
			then
				if [ "$ACCESSFREE" = "DO" ]
				then
					echo "s/^&&//" >> $TEMP
					echo "/^%%/d" >> $TEMP
				else
					echo "s/^%%//" >> $TEMP
					echo "/^&&/d" >> $TEMP
				fi
			else
				echo "/^%%/d" >> $TEMP
				echo "/^&&/d" >> $TEMP
			fi

			sed -f $TEMP < $DRIVER/$MESSAGES/append >  $SEND

			if [ -f $DRIVER/$ML/info.$ML ]
			then
				echo "--<Information of $ML ML>----------" >> $SEND
				cat $DRIVER/$ML/info.$ML	>> $SEND
			fi
			sed -f $TEMP < $DRIVER/$MESSAGES/manual >> $SEND

			TOUSER=1

			AD="$ADDRESS"
			if [ "$GCOS" != "" ]
			then
				AD="$ADDRESS (`echo $GCOS | sed -e 's/^__SGCOS__//' -e 's/__EGCOS__$//'`)"
			fi

			SEDADD=`echo $AD | sed  -e 's/\\\\/\\\\\\\\/g' \
						-e 's/\\//\\\\\\//g'   \
						-e 's/&/\\\\&/g'`

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$SEDADD/
			      s/%kEyWd%/$KEY/
			      s/%AdMiN%/$ML-request@$DOMAIN/
			      s/%CNtLAdRs%/$MYADDRESS/
			      s/%MlNaMe%/$ML@$DOMAIN/
			      s/%mOdE%/$SMODE/
			" > $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/add	> $SYSM
			cat $PROFILE/$NUM		       >> $SYSM
			SYSSUB="Append member."
			TOMEMB=1
		fi
		rm -rf $LOCK
	else
		SENDSUB="Append message from $ADDRESS"
		ADDRESS=$ML-request@$DOMAIN
		cat $HEAD $BODY > $SEND
		TOUSER=1
	fi
	;;
PING|GCOS|MEMBER|DIGEST|STOP|SEND|DELETE|INTRO|PROFILE|ADDRESS|KEYWORD|POSTADD|POSTDEL)
	set `egrep -v '[*?[]' $BODY` .
	NUM="`echo 0000$1 | sed -e 's/.*\(....\)$/\1/'`"
	KEY=$2
	USER=`egrep "^$NUM" $LIST`
	if [ "$USER" ]
	then
		set `echo $USER` .
		ORGKEY=$4

		if [ "$KEY" != "$ORGKEY" ]
		then
			ERROR=1
		fi
	else
		ERROR=1
	fi

	if [ $ERROR -eq 0 ]
	then
		case $SUBJECT in
		PING)
			cat $HEAD > $TMP2
			set `$GREP "^$NUM" $LIST` "????" "????" "????" "????"
			NU=$1
			ST=$2
			AD=`echo $3 | \
			    sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			GC="`$GREP $NU $GCOSFILE | \
			     sed -e 's/^[0-9]* //' -e 's/[ 	]*$//' \
				 -e 's/\\\\/\\\\\\\\/g' \
				 -e 's/\\//\\\\\\//g'	\
				 -e 's/&/\\\\&/g'`"

			if [ "$GC" != "" ]
			then
				AD="$AD ($GC)"
			fi

			echo "s/%MlNaMe%/$ML@$DOMAIN/
			      s/%NuMbEe%/$NU/
			      s/%SMoDe%/$ST/
			      s/%KeYwOrD%/$PW/
			      s/%AdDrEsS%/$AD/" > $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/check	    >  $SEND

			PO="`$GREP $NU $POST`"
			if [ "$PO" != "" ]
			then
				echo ""				    >> $SEND
				cat $DRIVER/$MESSAGES/check-post    >> $SEND
				echo ""				    >> $SEND
				echo "$PO" | \
					$AWK '{printf("	%s\n",$2)}' >> $SEND
			fi

			if [ "$ARCHIVE" = "DO" ]
			then
				echo ""				    >> $SEND
				cat $DRIVER/$MESSAGES/check-last    >> $SEND
				echo ""				    >> $SEND
				cd $SPOOL
				FILEMAX=`ls */* |\
					egrep "[0-9][0-9][0-9][0-9][0-9][0-9][0-9]" |\
					sort -nr | head -1`
				sed -n -e '1,/^$/p' < $FILEMAX > $HEAD
				FROM=`egrep "^[Ff][Rr][Oo][Mm]:" $HEAD |\
				      sed 's/[Ff][Rr][Oo][Mm]: //'`

				SUBJECT=`egrep "^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:" $HEAD|\
					 sed -e 's/[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:[ 	]*\[[A-z0-9=+-]*:[0-9]*\][ 	]*//'`
				N=`echo $FILEMAX | sed -e 's/.*\///'`
				echo "$N: $SUBJECT = $FROM"            >> $SEND
			fi

			echo ""					    >> $SEND
			cat $DRIVER/$MESSAGES/check-head	    >> $SEND
			echo ""					    >> $SEND
			cat $TMP2 $BODY | \
			  sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' >> $SEND

			TOUSER=1
			;;
		MEMBER)
			if [ "$USEMEMBER" != "DONT" ]
			then
				cat $DRIVER/$MESSAGES/member		> $SEND
				cat $LIST |\
					$AWK '{
						printf("%s|%s|%s\n",$1,$2,$3);
					}' |\
					sed -e "s/<//" -e "s/>//" \
					    -e "s/(//" -e "s/)//" |\
					sort -n		        > $TEMP

				while read D
				do
					set `echo $D | sed -e 's/|/ /g'`
					GC=`egrep "^$1" $GCOSFILE 2>/dev/null|\
					sed -e 's/^[0-9]* //' -e 's/[ 	]*$//'`
					if [ "$GC" != "" ]
					then
						echo "$D ($GC)"        >> $SEND
					else
						echo "$D"              >> $SEND
					fi
				done < $TEMP
				cat $DRIVER/$MESSAGES/member-end       >> $SEND

				TOUSER=1
			else
				if [ $MEMBMSG -eq 1 ]
				then
					ERROR=1
				else
					cat $DRIVER/$MESSAGES/dontusememb>$SEND
					TOUSER=1
				fi
			fi
			;;
		DIGEST)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			set `echo $USER` .
			NU=$1
			AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			ORGADRS=$AD

			echo "/^$NU /d
                                w
                                q
			" | ed >/dev/null 2>&1 $LIST
			echo "$NU DGST ($AD) $PW <nobody>" >> $LIST
			CHANGE=1

			if [ ! -f $DRIVER/$ML/batchtime ]
			then
				echo "03:00" > $DRIVER/$ML/batchtime
			fi

			SEDADD=`echo $AD | sed  -e 's/\\\\/\\\\\\\\/g' \
						-e 's/\\//\\\\\\//g'   \
						-e 's/&/\\\\&/g'`

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$SEDADD/
			      s/%MlNaMe%/$ML@$DOMAIN/
			"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/digest  > $SYSM
			cat $DRIVER/$ML/batchtime               >> $SYSM
			echo "-EOF-"                            >> $SYSM

			sed -f $TEMP < $DRIVER/$MESSAGES/digest  > $SEND
			cat $DRIVER/$ML/batchtime               >> $SEND
			echo "-EOF-"                            >> $SEND

			SYSSUB="Send by digest style to $AD."
			TOUSER=1
			TOMEMB=1
			if [ "$DLVMSG" != "DO" ]
			then
				AUTOMSG=DONT
			fi
			rm -f $LOCK
			;;
		STOP)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			set `echo $USER` .
			NU=$1
			MD=$2
			AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4
			ORGADRS=$AD

			echo "/^$NU /d
                                w
                                q
			" | ed >/dev/null 2>&1 $LIST
			echo "$NU STOP ($AD) $PW <nobody>" >> $LIST
			CHANGE=1

			SEDADD=`echo $AD | sed  -e 's/\\\\/\\\\\\\\/g' \
						-e 's/\\//\\\\\\//g'   \
						-e 's/&/\\\\&/g'`

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$SEDADD/
			      s/%MlNaMe%/$ML@$DOMAIN/
			"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/stop > $SYSM
			sed -f $TEMP < $DRIVER/$MESSAGES/stop > $SEND
			SYSSUB="Stop member."
			TOMEMB=1
			TOUSER=1
			if [ "$DLVMSG" != "DO" ]
			then
				AUTOMSG=DONT
			fi

			# Check digest spool.
			if [ "$MD" = "DGST" ]
			then
				cat $DGSTFILE  >> $SEND
				echo ""        >> $SEND
				echo "-------- End Digest of $ML ML --------" >> $SEND
			fi
			echo ""      >> $SEND
			echo "-EOF-" >> $SEND

			rm -f $LOCK
			;;
		SEND)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			set `echo $USER` .
			NU=$1
			MD=$2
			AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			ORGADRS=$AD

			echo "/^$NU /d
                                w
                                q
			" | ed >/dev/null 2>&1 $LIST
			echo "$NU SEND <$AD> $PW" >> $LIST
			CHANGE=1

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$AD/
			      s/%MlNaMe%/$ML@$DOMAIN/
			"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/send > $SYSM
			sed -f $TEMP < $DRIVER/$MESSAGES/send > $SEND
			TOUSER=1
			TOMEMB=1
			SYSSUB="Reregist member."
			if [ "$DLVMSG" != "DO" ]
			then
				AUTOMSG=DONT
			fi

			# Check digest spool.
			if [ "$MD" = "DGST" ]
			then
				cat $DGSTFILE  >> $SEND
				echo ""        >> $SEND
				echo "-------- End Digest of $ML ML --------" >> $SEND
			fi
			echo ""      >> $SEND
			echo "-EOF-" >> $SEND

			rm -f $LOCK
			;;
		DELETE)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			set `echo $USER` .
			NU=$1
			AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			ORGADRS=$AD

			echo "/^$NU /d
                                w
                                q
			" | ed >/dev/null 2>&1 $GCOSFILE

			echo "/^$NU /d
                                w
                                q
			" | ed >/dev/null 2>&1 $LIST
			echo "$NU QUIT () <nobody>" >> $LIST
			CHANGE=1

			rm -f $PROFILE/$NU

			if [ -f $POST ]
			then
				echo "g/^$NU /d
                                      w
                                      q
				" | ed >/dev/null 2>&1 $POST
			fi

			SEDADD=`echo $AD | sed  -e 's/\\\\/\\\\\\\\/g' \
						-e 's/\\//\\\\\\//g'   \
						-e 's/&/\\\\&/g'`

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$SEDADD/
			      s/%MlNaMe%/$ML@$DOMAIN/
			"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/delete > $SYSM
			sed -f $TEMP < $DRIVER/$MESSAGES/delete > $SEND
			SYSSUB="Delete member."
			TOMEMB=1
			TOUSER=1
			rm -f $LOCK
			;;
		ADDRESS)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			set `echo $USER` .
			NU=$1
			OA=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			set `cat $BODY | \
			sed 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' | \
			egrep "^address"` . .

			AD=$2

			ORGADRS=$AD

			if [ "$AD" = "." ]
			then
				ERROR=1
			else
				set `egrep "^$NU" $LIST` . .
				MODE=$2
				echo "/^$NU /d
                                        w
                                        q
				" | ed >/dev/null 2>&1 $LIST

				if [ "$MODE" = "SEND" ]
				then
					UINFO="$NU SEND <$AD> $PW"
				else
					UINFO="$NU $MODE ($AD) $PW <nobody>"
				fi
				echo $UINFO >> $LIST
				CHANGE=1

				GC="`$GREP $NU $GCOSFILE | \
			     		sed -e 's/^[0-9]* //' \
					    -e 's/[ 	]*$//' \
					    -e 's/\\\\/\\\\\\\\/g' \
					    -e 's/\\//\\\\\\//g' \
					    -e 's/&/\\\\&/g'`"

				if [ "$GC" != "" ]
				then
					AD="$AD ($GC)"
				fi

				echo "s/%MlNaMe%/$ML@$DOMAIN/
				      s/%NuMbEe%/$NU/
				      s/%SMoDe%/$MODE/
				      s/%KeYwOrD%/$PW/
				      s/%AdDrEsS%/$AD/" > $TEMP

				sed -f $TEMP < $DRIVER/$MESSAGES/check > $SEND
				echo ""				      >> $SEND
				cat $DRIVER/$MESSAGES/change	      >> $SEND
				echo ""				      >> $SEND
				echo "	$OA -> $AD" | \
					sed -e 's/(.*)//'	      >> $SEND

				PO="`$GREP $NU $POST`"
				if [ "$PO" != "" ]
				then
					echo ""			        >>$SEND
					cat $DRIVER/$MESSAGES/check-post>>$SEND
					echo ""			        >>$SEND
					echo "$PO" | \
						$AWK '{printf("	%s\n",$2)}' >> $SEND
				fi

				TOUSER=1
			fi
			rm -f $LOCK
			;;
		POSTADD)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			echo "s/%MlNaMe%/$ML@$DOMAIN/"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/postadd > $SEND
			set `echo $USER` .
			NU=$1

			set `cat $BODY | \
			sed 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' | \
			egrep "^postadd"` . .

			AD=$2

			ORGADRS=$AD

			if [ "$AD" = "." ]
			then
				ERROR=1
			else
				grep "$NU <$AD>" $POST >/dev/null 2>&1
				if [ $? -eq 0 ]
				then
					sed -f $TEMP < $DRIVER/$MESSAGES/postdup > $SEND
				else
					echo "$NU <$AD>" >> $POST
				fi

				CHANGE=1

				echo "$AD" >> $SEND

				TOUSER=1
			fi
			rm -f $LOCK
			;;
		POSTDEL)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			echo "s/%MlNaMe%/$ML@$DOMAIN/"> $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/postdel > $SEND
			set `echo $USER` .
			NU=$1

			set `cat $BODY | \
			sed 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' | \
			egrep "^postdel"` . .

			AD=$2

			ORGADRS=$AD

			if [ "$AD" = "." ]
			then
				ERROR=1
			else
				egrep "^$NU <$AD>" $POST >/dev/null 2>&1
				if [ $? -ne 0 ]
				then
					ORGADRS=
					sed -f $TEMP < $DRIVER/$MESSAGES/postnon > $SEND
				else
					echo "/^$NU <$AD>/d
                                              w
                                              q
					" | ed >/dev/null 2>&1 $POST
				fi

				CHANGE=1
				echo "$AD" >> $SEND
				TOUSER=1
			fi
			rm -f $LOCK
			;;
		INTRO)

			echo "s/%MlNaMe%/$ML@$DOMAIN/"> $TEMP
			sed -f $TEMP < $DRIVER/$MESSAGES/intro > $SEND

			set `echo $USER` .
			NU=$1
			sed -n -e '/^./,$p' < $BODY > $TEMP
			set `wc -l $TEMP`
			LINE=`expr $1 - 1`
			echo "<<Last Modified: `date`>>" > $PROFILE/$NUM
			tail -$LINE $TEMP		>> $PROFILE/$NUM

			cat $PROFILE/$NUM >> $SEND
			TOUSER=1
			;;
		KEYWORD)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			set `echo $USER` .
			NU=$1
			AD=`echo $3 |\
			sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			OP=$4

			ORGADRS=$AD
 
			set `cat $BODY | \
			sed 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' | \
			egrep "^keyword [0-9][0-9][0-9][0-9]"` . .
 
			PW=$2
			if [ "$PW" = "." ]
			then
				ERROR=1
			else
				KE=`echo $PW | sed -e 's/.*\(....\)$/\1/'`
				if [ "$PW" = "$KE" ]
				then
					set `egrep "^$NU" $LIST` . .
					MODE=$2
					echo "/^$NU /d
                                                w
                                                q
					" | ed >/dev/null 2>&1 $LIST
					if [ "$MODE" = "SEND" ]
					then
						UINFO="$NU SEND <$AD> $PW"
					else
						UINFO="$NU $MODE ($AD) $PW <nobody>"
					fi
					echo $UINFO >> $LIST
					CHANGE=1
 
					GC="`$GREP $NU $GCOSFILE | \
						sed -e 's/^[0-9]* //' \
						    -e 's/[ 	]*$//' \
						    -e 's/\\\\/\\\\\\\\/g' \
						    -e 's/\\//\\\\\\//g' \
						    -e 's/&/\\\\&/g'`"

					if [ "$GC" != "" ]
					then
						AD="$AD ($GC)"
					fi

					echo "s/%MlNaMe%/$ML@$DOMAIN/
					      s/%NuMbEe%/$NU/
					      s/%NuMbEe%/$NU/
					      s/%SMoDe%/$MODE/
					      s/%KeYwOrD%/$PW/
					      s/%AdDrEsS%/$AD/" > $TEMP

					sed -f $TEMP < $DRIVER/$MESSAGES/check >> $SEND
					echo ""				       >> $SEND
					cat $DRIVER/$MESSAGES/change-key       >> $SEND
					echo ""				       >> $SEND
					echo "	$OP -> $PW"		       >>$SEND

					PO="`$GREP $NU $POST`"

					if [ "$PO" != "" ]
					then
						echo "" >> $SEND
						cat $DRIVER/$MESSAGES/check-post >> $SEND
						echo "" >> $SEND
						echo "$PO" |\
							$AWK '{printf("	%s\n",$2)}' >> $SEND
					fi

					TOUSER=1
				else
					ERROR=1
				fi
			fi
			rm -f $LOCK
			;;

		GCOS)
			# Get lock.
			DELAY=`expr $MYPID % 6`

			# Get delay time.
			case "$DELAY" in
			0)	set 1 2 3 3 2 1 ;;
			1)	set 1 3 2 1 2 3 ;;
			2)	set 2 1 3 1 3 2 ;;
			3)	set 2 3 1 2 1 3 ;;
			4)	set 3 1 2 2 3 1 ;;
			*)	set 3 2 1 3 1 2 ;;
			esac

			umask 077
			until ln $LKEY $LOCK >/dev/null 2>&1
			do
				DELAY=$1
				shift
				set $@ $DELAY
				sleep $DELAY
			done
			# Lock comprele.
			umask 022

			echo "s/%MlNaMe%/$ML@$DOMAIN/"> $TEMP
			sed -f $TEMP < $DRIVER/$MESSAGES/gcos > $SEND
 
			set `echo $USER` .
			NU=$1
			AD=`echo $3 |\
			sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			OP=$4
 
			GCOS="`$GREP -i GCOS $BODY | head -1 | sed -e 's/[ 	]*[Gg][Cc][Oo][Ss][ 	]*//'`"

			if [ "$GCOS" = "" ]
			then
				ERROR=1
			else
				echo "/^$NU /d
                                        w
                                        q
				" | ed >/dev/null 2>&1 $GCOSFILE
				echo "$NU $GCOS" | sed -e 's/[ 	]*$//' >> $GCOSFILE
				echo ""          >> $SEND
				echo "$NU $GCOS" >> $SEND
				TOUSER=1
			fi
			rm -f $LOCK
			;;

		PROFILE)
			cd $PROFILE

			FILEMIN=`ls | egrep "[0-9][0-9][0-9][0-9]" | sort -n  | head -1`
			FILEMAX=`ls | egrep "[0-9][0-9][0-9][0-9]" | sort -nr | head -1`

			if [ "$FILEMIN" = "" ]
			then
				FILEMIN=1
			fi
			if [ "$FILEMAX" = "" ]
			then
				FILEMAX=1
			fi

			cat $BODY | \
			sed 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/' |\
			egrep '^[ 	]*PROFILE' |\
			sed -e 's/^[ 	]*PROFILE[ 	]*//' > $TEMP

			set X`cat $TEMP`

			if [ "$1" = "X" ]
			then
				echo ALL > $TEMP
			fi

			SYNOK=0
			for i in `sed 's/,/ /g' < $TEMP`
			do
				case $i in
				ALL)
					SYNOK=1
					MIN=$FILEMIN
					MAX=$FILEMAX
					I=$MIN
					while [ $I -le $MAX ]
					do
						CUR=`echo 0000$I | sed -e 's/.*\(....\)$/\1/'`
						if [ -s $CUR ]
						then
							FILES="$FILES $CUR"
						fi
						I=`expr $I + 1`
					done
					;;
				[0-9]*-[0-9]*|-[0-9]*|[0-9]*-)
					SYNOK=1
					MIN=`expr $i : '^\(.*\)-'`
					MAX=`expr $i : '.*-\(.*\)$'`
					if [ ! "$MIN" ]
					then
						MIN=$FILEMIN
					fi
					if [ ! "$MAX" ]
					then
						MAX=$FILEMAX
					fi
					expr $MIN + $MAX >/dev/null 2>&1
					if [ $? -ne 0 ]
					then
						SYNOK=0
						ERROR=1
						SUBJECT=
					else
						I=$MIN
						while [ $I -le $MAX ]
						do
							CUR=`echo 0000$I | sed -e 's/.*\(....\)$/\1/'`
							if [ -s $CUR ]
							then
								FILES="$FILES $CUR"
							fi
							I=`expr $I + 1`
						done
					fi
					;;
				[0-9]*)
					SYNOK=1
					I="`echo 0000$i | sed -e  's/.*\(....\)$/\1/'`"
					expr $I + 0 >/dev/null 2>&1
					if [ $? -ne 0 ]
					then
						SYNOK=0
						ERROR=1
						SUBJECT=
						break
					fi
					if [ -s $I ]
					then
						FILES="$FILES $I"
					fi
					;;
				esac
			done

			if [ ! "$FILES" ]
			then
				if [ $SYNOK -eq 1 ]
				then
					cat $DRIVER/$MESSAGES/noprof  > $SEND
					sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $HEAD >> $SEND
					cat $BODY		     >> $SEND

					SENDSUB="No profile is good profile"
					TOUSER=1
					TOMEMB=0
					SUBJECT=
				else
					ERROR=1
				fi
			fi

			if [ "$SUBJECT" ]
			then
				cd $PROFILE
				echo "** Profile of $ML@$DOMAIN **"  > $SEND
				for i in $FILES
				do
					egrep "^$i" $LIST | $AWK '{
					 printf("\n>>> %s: %s (%s) <<<\n", $1,$3,$2)
					}'			    >> $SEND
					cat $i			    >> $SEND
				done
				TOUSER=1
			fi
			;;
		*)
			;;
		esac
	fi
	;;
*)
	ERROR=1
	;;
esac

if [ $CHANGE -eq 1 ]
then
	egrep "^[0-9]* SEND" $LIST | sed -e 's/.*<//' -e 's/>.*//' > $DELV

	if [ ! -s $DELV ]
	then
		echo "nobody" > $DELV
	fi

	if [ -f $DRIVER/$STATIC ]
	then
		cat /dev/null > $TEMP
		for i in `$AWK '{print $1}' < $DRIVER/$STATIC`
		do
			set `grep -i $i $DELV | sed -e 's/@/ /'` . .
			U=$1
			D=$2
			if [ "$U" != "." ]
			then
				set `grep -i $i $DRIVER/$STATIC`
				R=$2
				echo "s/@$D/%$D@$R/" >> $TEMP
			fi
		done

		if [ "`cat $TEMP`" != "" ]
		then
			sed -f $TEMP < $DELV > $TMP2
			cat $TMP2 > $DELV
		fi
	fi
fi

if [ $ERROR -eq 1 ]
then
	echo "s/%CNtLAdRs%/$MYADDRESS/
	      s/%MlNaMe%/$ML@$DOMAIN/"	> $TEMP

	if [ "$USECHECK" != "DONT" ]
	then
		echo "s/^((//" >> $TEMP
	else
		echo "/^((/d" >> $TEMP
	fi

	if [ "$USEMEMBER" != "DONT" ]
	then
		echo "s/^))//" >> $TEMP
	else
		echo "/^))/d" >> $TEMP
	fi

	if [ "$ARCHIVE" = "DO" ]
	then
		if [ "$ACCESSFREE" = "DO" ]
		then
			echo "s/^&&//" >> $TEMP
			echo "/^%%/d" >> $TEMP
		else
			echo "s/^%%//" >> $TEMP
			echo "/^&&/d" >> $TEMP
		fi
	else
		echo "/^%%/d" >> $TEMP
		echo "/^&&/d" >> $TEMP
	fi

	cat $DRIVER/$MESSAGES/error				 > $SEND
	sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $HEAD     >> $SEND
	cat $BODY						>> $SEND
	sed -f $TEMP < $DRIVER/$MESSAGES/manual			>> $SEND

	SUBJECT="ERROR"
	REPLYTO=$ML-control@$DOMAIN
	SENDSUB="$SENDSUB error"
	TOUSER=1
	TOMEMB=0
fi

# mail send to user
if [ "$ORGADRS" = "." ]
then
	ORGADRS=
fi

if [ $TOUSER -eq 1 ]
then
	echo "To: $ADDRESS"			         > $HEAD
	if [ "$ORGADRS" != "" -a "$ADDRESS" != "$ORGADRS" ]
	then
		echo "Cc: $ORGADRS"                     >> $HEAD
	fi
	echo "From: $ML-request@$DOMAIN ($ML ML admin)" >> $HEAD
	echo "Subject: $SENDSUB."		        >> $HEAD
	echo "Errors-To: $ML-request@$DOMAIN"	        >> $HEAD
	echo "X-ML-Driver: CMAS (Version $VERSION)"     >> $HEAD
	echo $LOOPCHECK					>> $HEAD

	case $SUBJECT in
	GET|MANUAL|HELP|APPEND|MANUALADD|ACKAPPEND|ERROR)
		if [ "$REPLYTO" ]
		then
			echo "Reply-To: $REPLYTO"       >> $HEAD
		else
			echo "Reply-To: $ML@$DOMAIN"    >> $HEAD
		fi
	;;
	esac

	if [ "$SENDER" ]
	then
		echo "Sender: $SENDER"			>> $HEAD
	fi

	if [ "$PRECEDENCE" ]
	then
		echo "Precedence: $PRECEDENCE"		>> $HEAD
	fi
	echo ""						>> $HEAD

	cat $HEAD $SEND | b64decode| $SENDMAIL -oi -t -f$UNIXFROM
fi

if [ $TOMEMB -eq 1 ]
then
	if [ "$AUTOMSG" = "DO" ]
	then
		echo "To: $ML@$DOMAIN"		         > $HEAD
	else
		echo "To: $ML-request@$DOMAIN"	         > $HEAD
	fi

	echo "From: $ML-request@$DOMAIN ($ML ML admin)" >> $HEAD
	echo "Subject: $SYSSUB"			        >> $HEAD
	echo $LOOPCHECK					>> $HEAD

	if [ "$SENDER" ]
	then
		echo "Sender: $SENDER"		        >> $HEAD
	fi

	if [ "$PRECEDENCE" ]
	then
		echo "Precedence: $PRECEDENCE"		>> $HEAD
	fi
	echo ""					        >> $HEAD

	cat $HEAD $SYSM | b64decode | $SENDMAIL -oi -t -f$UNIXFROM
fi

exit 0
